// This is part of emulator.cc of GameBoy emulator.
// Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)

#include "timer.h"

static void DivUpdater();
static class divreg
{
	byte value;
	timer tim;
public:
	divreg() : value(0), tim(16384, DivUpdater)
	{
	}
	inline byte read() const
	{
		return value;
	}
	inline void write(const byte)
	{
		value = 0;
	}
	inline void update()
	{
		++value;
	}
} DIV;

static void DivUpdater()
{
	DIV.update();
}
