// This is part of emulator.cc of GameBoy emulator.
// Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)

static class Joypad
{
	bool gettype;
	bool P15, P14;	// P14=arrows enabled, P15=buttons enabled
public:
	Joypad() : gettype(false)
	{
		P14=P15 = true;
	}
	inline byte read()
	{
		if(gettype)
		{
			gettype = false;
			// 3x indicates Super Gameboy
			// Fx indicates GameBoy or GameBoy pocket.
			return SuperGameBoy ? 0xF3 : 0x33;
		}
		return 0;
		// Buttons:
		//    1    2   4,  8, 10,20, 40,   80
		//  Right,Left,Up,Down,A,B,Select,Start		
	}
	inline void write(const byte data)
	{
		gettype = (data==3);
		P14 = !(data&0x10);
		P15 = !(data&0x20);
	}
} P1;
